/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/*global iw_form YAHOO IW_AC_DATA */
var doItNow = function (suggestion) {
    let input;

    if (input = $('#iw-in-iw_awesome_input')) {
        input.val('##LG_PLEASEWAIT##');
        window.location = suggestion.value;
    }
};

/*
 * Function to determine matches for the awesome bar
 *
 * @param string sQuery
 * @return array
 */
var awesomeMatch = function (sQuery) {
    sQuery = $.trim(decodeURI(sQuery.replace('%3A', ' '))).toLowerCase();

    let id          = 'iw-in-iw_awesome_input',
        data        = IW_AC_DATA[id],
        parts       = sQuery.split(' '),
        count_parts = parts.length,
        matches     = [],
        potential_match,
        i, j,
        count_data  = data.length;

    dataloop: for (i = 0; i < count_data; ++i) {
        potential_match = data[i];
        potential_match.d = $('<div/>').html(potential_match.d).text();

        for (j = 0; j < count_parts; ++j) {
            if (potential_match.d.toLowerCase().indexOf(parts[j]) === -1 &&
                potential_match.v.toLowerCase().indexOf(parts[j]) === -1) {
                continue dataloop;
            }
        }
        matches[matches.length] = {
            'value': potential_match.v,
            'label': potential_match.d
        };
    }

    return matches;
};

if ($('#iw_awesome_input')) {
    let input = $('#iw-in-iw_awesome_input'),
        AC = {};

    input.attr('tabindex', 1);
    //input.closest('div').css('z-index', 0);

    input.typeahead(
        {
            minLength: 1,
            highlight: true,
            hint     : true
        },
        {
            source : function (query, process) {
                let links = [];
                let map = {};

                let data = awesomeMatch(query);

                $.each(data, function (i, link) {
                    map[link.value] = $('<div/>').html(link.label).text();
                    links.push(link);
                });

                process(links);
            },
            display: function (suggestion) {
                return suggestion.label;
            },
            limit  : 10,
            // display: 'label'
        }
    ).bind('typeahead:select', function (e, suggestion) {
        doItNow(suggestion);
        e.preventDefault();
    });

    if (!input.attr('placeholder')) {
        input.attr('placeholder', '##LG_SEARCH##...');
    }

    input.focus(iw_form.onACFocus);

    AC.applyLocalFilter = true;
    AC.queryMatchContains = true;

    iw_form.registeredACs[input.attr('id')] = AC;

    // Handle Ctrl+Space trigger
    let down = [];
    $(document).keydown(function (e) {
        down[e.keyCode] = true;
    }).keyup(function (e) {
        if (down[17] && down[32]) {
            input.focus();
        }
        down[e.keyCode] = false;
    });
}//end if
