/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/*global YAHOO iw_js_data iw_form, iw_xhr*/

/*
 * a global object to contain everything related to log viewer forms
 */
var iw_log_viewer = {
    first    : true,
    following: false,
    t        : null,
    t2       : null,

    /*
     * stupid javascript not know how to submit a form if there is an input named
     * submit...  web standards fail.
     */
    submit_form: function () {
        iw_form.getSubmitButton(document.LogView).click();
    },

    /*
     * turns on follow
     */
    start_follow: function () {
        iw_log_viewer.t2 = setTimeout(iw_log_viewer.stop_follow, 1000 * 60 * 5); // stop after 5 minutes
    },

    /*
     * turns off follow
     */
    stop_follow: function () {
        document.getElementById('follow').value = '0';
    },

    /*
     * on follow input change
     */
    check_follow: function () {
        let follow = document.getElementById('iw-in-follow');
        if (follow.value === '1') {
            if (iw_log_viewer.following === false) {
                iw_log_viewer.start_follow();
                iw_log_viewer.following = true;
            }
            iw_log_viewer.t = setTimeout(
                iw_log_viewer.submit_form,
                iw_js_data.xhr_log_reload * 1000
            );
        } else {
            clearTimeout(iw_log_viewer.t);
            clearTimeout(iw_log_viewer.t2);
        }
    },

    /*
     * on file input change
     */
    check_file: function () {
        clearTimeout(iw_log_viewer.t);
        iw_log_viewer.submit_form();
    },

    /*
     * Takes the reply data and renders it to the proper element in the dom.
     * Will fix the scroll bar so that it will go to the bottom of the page,
     * if needed.
     */
    renderLog: function (e, d) {
        let r        = d.reply,
            options  = d.options,
            data     = r.getReplyData(),
            log_pre  = document.getElementById('iw-log-content');

        options.display_banner = false;
        options.prevent_redirect = true;

        let new_content = "<span>-nothing here-</span>";

        if (!data) {
            //
        } else {
            new_content = data.replace(/\n\n/g, '\n')
            new_content = '<span>' + new_content.replace(/\n/g, '</span><span>') + '</span>';
        }
        log_pre.innerHTML = new_content;

        iw_log_viewer.check_follow();
    },
    /*
     * This function ensures that the viewport is the correct size in proprotion to
     * the user's browser size.
     */
    resize_viewport: function () {
        let y            = $('#iw-log-container').position().top,
            viewportSize = $(window).height(),
            newSize      = ((viewportSize - y) - 120) + 'px';

        $('#iw-log-content').parent().height(newSize);
    },

    download_log: function (e) {
        let file  = document.getElementById('file'),
            group = document.getElementById('group');

        e.stopPropagation();
        e.preventDefault();

        if (group === null) {
            window.location = '?action=downloadCommit&' + 'file=' + file.value;
        } else {
            window.location = '?action=downloadCommit&group=' + group.value +
                              '&file=' + file.value;
        }
    }
};

iw_xhr.subscribeTo(iw_log_viewer.renderLog, 'viewCommit');

$(window).resize(iw_log_viewer.resize_viewport);

// if follow is changed, we should update the timeout immediately instead of
// waiting for the next cycle through
$('#file').change(iw_log_viewer.check_file);
$('#log-download').click(iw_log_viewer.download_log);
$(document).ready(function () {
    iw_log_viewer.resize_viewport();
    iw_log_viewer.submit_form();
});
