/* jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/* global $ iw_xhr iw_message yumLogHandler iw_lib */
/*
 * Base class to display logs in a popup panel
 */
var showLogHandler = {
    responder     : '',
    isStillRunning: false,
    repeatEvery   : 3000,
    timeout       : null,
    paused        : false,
    logPanel      : null,
    input         : null,
    makeLogPanel  : function () {
        let header = 'Output of ' + this.responder +
                     '<i id="iw-file-output-spinner" ' +
                     ' class="' + IW.icons._BASE + ' ' + IW.icons.PENDING + ' ' + IW.icons.SPIN + '"></i>';
        let footer = '<i id="iw-file-output-control" ' +
                     ' class="' + IW.icons._BASE + ' ' + IW.icons.PAUSE + ' ' + IW.icons.colors.INFO + '"></i>';

        let modal = '<div class="modal" id="' + this.responder + '">' +
                    '<div class="modal-dialog modal-dialog-scrollable modal-xl iw-modal-full-height">' +
                    '<div class="modal-content">' +
                    '<div class="modal-header">' +
                    '<div class="modal-title">' + header + '</div>' +
                    '<button type="button" class="close pt-2 pr-2" data-dismiss="modal" aria-hidden="true">' +
                    '<i class="mdi mdi-close-circle"></i>' +
                    '</button>' +
                    '</div>' + // End modal-header
                    '<div class="modal-body iw-log-output" id="' + this.responder + '_body"></div>' +
                    '<div class="modal-footer">' + footer + '</div>' +
                    '</div>' + // End modal-content
                    '</div>' + // End modal-dialog
                    '</div>';  // End modal

        $('body').append(modal);

        return $('#' + this.responder);

    },
    onComplete    : function () {
        let target  = document.getElementById('iw-file-output-control'),
            spinner = document.getElementById('iw-file-output-spinner');

        this.isStillRunning = false;
        iw_lib.updateIWIcon(target, IW.icons.PAUSE, IW.icons.colors._RESET);
        iw_lib.updateIWIcon(spinner, IW.icons.BLANK);
        $('.modal-footer').off('click', '*');
        $(this).trigger('logComplete');
    },
    onPause       : function (e) {
        this.paused = true;

        let target = e.target;
        $('#iw-file-output-control').off('click');
        iw_lib.updateIWIcon(target, IW.icons.START);
        $('.modal-footer').on('click', '*', $.proxy(this.onPlay, this));
    },
    onPlay        : function (e) {
        this.paused = false;
        this.execute(e);
        let target  = e.target,
            spinner = $('#iw-file-output-spinner');
        $('#iw-file-output-control').off('click').parent().off('click');
        iw_lib.updateIWIcon(target, IW.icons.PAUSE);
        iw_lib.updateIWIcon(spinner, IW.icons.PENDING);
        $('.modal-footer').on('click', '*', $.proxy(this.onPause, this));
    },
    handle201     : function (logReply) {
        let logWindow = document.getElementById(this.responder + '_body'), that = this, new_content;

        if (!logWindow) {
            this.logPanel = this.makeLogPanel();
            $('.modal-footer').on('click', '*', $.proxy(this.onPause, this));
            logWindow = document.getElementById(this.responder + '_body');
        }

        if (this.paused === false) {
            this.logPanel.modal('show');
        }
        new_content = logReply.getReplyData().fileContent.replace(/\n\n/g, '\n');
        new_content = '<pre>' + new_content + '</pre>';

        // Put this in an if statement because it can "blip"
        // on the screen if it isn't really necessary to do.
        if (logWindow.innerHTML !== new_content) {
            logWindow.innerHTML = new_content;
            logWindow.scrollTop = logWindow.scrollHeight;
            this.logPanel.modal('handleUpdate');
        }

        function refreshLog()
        {
            iw_xhr.getReply(that, that.input);
        }

        if (logReply.getReplyData().moreToCome === 1) {
            if (this.paused === false) {
                that.timeout = setTimeout(refreshLog, that.repeatEvery);
            }
        } else {
            that.onComplete();
        }
    },
    execute       : function (e) {
        if (e) {
            e.stopPropagation();
            e.preventDefault();
        }
        this.isStillRunning = true;
        this.paused = false;
        iw_xhr.getReply(this, this.input);
    },
    toString      : function () {
        return 'IWorx Log Handler for ' + this.responder;
    },
    show          : function (e) {
        this.paused = false;
        if (this.logPanel) {
            this.logPanel.center();
            this.logPanel.show();
        }
    }
};
