/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/*global showLogHandler iw_form iw_payload_widget iw_xhr iw_lib $ iw_payload iw_ctrl_handler */
/**
 Handler for displaying yum log during an update
 */
var yumLogHandler = Object.beget(showLogHandler);
yumLogHandler.responder = 'YumLastLog';
yumLogHandler.repeatEvery = 100;

var yumLogShower = function (e, data) {
    let options = data.options;

    options.display_banner = false;
    options.prevent_redirect = true;

    yumLogHandler.execute();
};

(function () {
    let available_updates = iw_payload_widget('available_updates-shell'),
        recent_history    = iw_payload_widget('recent_history-shell'),
        refreshLink       = $('.iw-refresh-updates'),
        refreshInput      = $('#refresh-button'),
        listUpdates;
    iw_xhr.subscribeTo(yumLogShower, 'applyCommit');
    $(available_updates).bind('logComplete', available_updates.refresh);
    $(recent_history).bind('logComplete', recent_history.refresh);

    function complete(r, success)
    {
        iw_lib.updateIWIcon(refreshInput, IW.icons.BLANK);
        available_updates.refresh();
    }

    listUpdates = function (e) {
        iw_lib.updateIWIcon(refreshInput, IW.icons.PENDING);
        e.stopPropagation();
        e.preventDefault();
        available_updates.markInProgress();
        iw_ctrl_handler.execute(null, complete, 'nodeworx/updates', 'refresh');
    };

    refreshLink.off('click');
    refreshLink.click(listUpdates);
})();
