/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true, laxbreak: true */
/*global $ */

var editSpamPrefs = {
    init: function () {
        let form             = document.forms.edit_spam_preferences,
            input            = form.enable_spam,
            showhides        = $('.iw-show-hide-link'),
            i,
            showhides_length = showhides.length;

        this.toggleDisabled();

        $(input).change(this.toggleDisabled);

        $(showhides).click(this.showHide);

        for (i = 0; i < showhides_length; ++i) {
            if (Cookies.get(showhides[i].id, Number) === 1) {
                this.showEl(showhides[i]);
            }
        }
    },

    toggleDisabled: function () {
        let form          = document.forms.edit_spam_preferences,
            input         = form.enable_spam,
            inputs        = form.elements,
            inputs_length = inputs.length,
            i;

        if (input.value === '1') {
            for (i = 0; i < inputs_length; ++i) {
                if (inputs[i].type !== 'hidden' &&
                    inputs[i].type !== 'submit' &&
                    inputs[i].type !== 'button' &&
                    inputs[i].name !== 'enable_spam') {
                    inputs[i].disabled = false;
                }
            }
        } else {
            for (i = 0; i < inputs_length; ++i) {
                if (inputs[i].type !== 'hidden' &&
                    inputs[i].type !== 'submit' &&
                    inputs[i].type !== 'button' &&
                    inputs[i].name !== 'enable_spam') {
                    inputs[i].disabled = true;
                }
            }
        }
    },

    showVal: '##LG_SHOWDETAILS##',

    hideVal: '##LG_HIDEDETAILS##',

    showEl: function (link) {
        let target = document.getElementById(link.id + '_target');

        target.style.display = 'block';
        link.innerHTML = editSpamPrefs.hideVal;
    },

    hideEl: function (link) {
        let target = document.getElementById(link.id + '_target');

        target.style.display = 'none';
        link.innerHTML = editSpamPrefs.showVal;
    },

    showHide: function (e) {
        let target = document.getElementById(this.id + '_target');

        e.stopPropagation();
        e.preventDefault();

        if (this.innerHTML === editSpamPrefs.showVal) {
            Cookies.set(this.id, 1);
            editSpamPrefs.showEl(this);
        } else {
            Cookies.set(this.id, 0);
            editSpamPrefs.hideEl(this);
        }
    }
};

editSpamPrefs.init();
