/*jslint undef: true, widget: true, browser: true, onevar: true, eqeqeq: true */
/*global $,
         iw_ctrl_handler,
         iw_payload_widget,
         iw_lib,
         iw_message,
         iw_message_banner,
         IW_PAYLOAD_DATA,
         iw_js_data
 */

(function () {
    let payload = iw_payload_widget('nodeworx_siteworx-shell');

    payload.refreshOn('suspendCommit');
    payload.refreshOn('unsuspendCommit');
})();

(function () {
    let execute_search = function ( e, element, shell ) {
        let payload         = iw_payload_widget('nodeworx_siteworx-shell'),
            search_box      = $('#siteworx-search-box').val(),
            search_all      = $('#siteworx-search-all'),
            reseller_select = $('#reseller_select'),
            reseller;

        if (search_all.val() === '1') {
            reseller = 'all';
        } else {
            reseller = reseller_select.val();
        }

        payload.setValue('query', search_box);
        payload.setValue('reseller', reseller);

        payload.go();
    },
    update_add_link = function (e) {
        let add_link = $('#siteworx-add-link');

        if ($(this).val() !== 'all') {
            add_link.href = '?action=add&reseller=' + $(this).val();
        } else {
            add_link.href = '?action=add';
        }
    },
    load_accounts = function (e) {
        let payload    = iw_payload_widget('nodeworx_siteworx-shell'),
            search_box = $('#siteworx-search-box');

        search_box.val('');

        payload.setValue('reseller', $(this).val());
        payload.setValue('query', '');

        payload.go();
    },
    toggle_select_all = function ( e ) {
        let search_all = $('#siteworx-search-all');

        if ($(this).val() === 'all') {
            search_all.val('1');
            search_all.disabled = true;
        } else {
            search_all.val('0');
            search_all.disabled = false;
        }
    },
    rsl_select = $('#reseller_select'),
    search_box = $('#siteworx-search-box'),
    shell;

    search_box.keypress(function (e) {
        if (e.which === 13) {
            execute_search();
        }
    });

    shell = iw_lib.getEl('nodeworx_siteworx-shell');
    if ( !shell.hasAttribute('data-iw-searchbox-delegate') ) {
        $('#siteworx-search').on('click', 'input.button', execute_search);
        shell.setAttribute('data-iw-searchbox-delegate', '1');
    }

    if (rsl_select !== null) {
        rsl_select.change(load_accounts);
        rsl_select.change(update_add_link);
        rsl_select.change(toggle_select_all);
    }
})();

(function () {
    let execute_fav = function ( e ) {
            let el     = e.target,
                tr     = $(this).closest('tr'),
                td     = $(tr).children('.td-checkbox'),
                chkbox = $(td).children('input'),
                input  = {domain: chkbox.val(), security_token: iw_js_data.iw_env.security_token},
                toggle, orig_state;

        orig_state = $(el).hasClass(IW.icons.colors.WARNING);

        iw_lib.toggleSpinner(el);

        toggle = function ( r, success, el ) {
            if ( success === false ) {
                //Boo!
                return;
            }

            iw_lib.toggleSpinner(el);

            if ( orig_state ) {
                iw_lib.updateIWIcon(el, IW.icons.STAR, IW.icons.colors._RESET);
            } else {
                iw_lib.updateIWIcon(el, IW.icons.STAR, IW.icons.colors.WARNING);
            }
        };

        iw_ctrl_handler.execute(
            null,
            { callback: toggle, args: this },
            'nodeworx/siteworx',
            'toggleFavoriteCommit',
            input
        );
    },
    shell = iw_lib.getEl('nodeworx_siteworx-shell');

    if (!shell.hasAttribute('data-iw-fav-delegate')) {
        $('#nodeworx_siteworx-shell').on('click', 'i.iw-fav', execute_fav);
        shell.setAttribute('data-iw-fav-delegate', '1');
    }
})();
